Object subclass: #MuOmniBaseAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase-Utils'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MuOmniBaseAccessor class
	instanceVariableNames: 'db dbRootDirectory dbSubDirectoryName'!

!MuOmniBaseAccessor class methodsFor: 'actions' stamp: 'MU 8/15/2005 18:14'!
closeAll
	OmniBase closeAll.! !

!MuOmniBaseAccessor class methodsFor: 'actions' stamp: 'mu 9/15/2005 19:02'!
closeDb
	(db notNil and: [db clientManager notNil])
		ifTrue: [ db numberOfClients = 0
				ifTrue: [db close]]! !

!MuOmniBaseAccessor class methodsFor: 'actions' stamp: 'mu 9/29/2005 11:31'!
commitDo: aBlock 
	| tra |
	[aBlock value: (tra := self db newTransaction)]
		ensure: [[tra commit]
				on: ODBLockingConflict
				do: [tra abort. self error: 'Transaction aborted!!']].! !

!MuOmniBaseAccessor class methodsFor: 'actions' stamp: 'MU 8/11/2005 17:20'!
createDb
	[db := OmniBase createOn: self dbDirectory fullName]
		ensure: [db close]! !

!MuOmniBaseAccessor class methodsFor: 'actions' stamp: 'MU 8/11/2005 16:53'!
openedDb
	| retry |
	db := nil.
	retry := 0.
	[db := OmniBase openOn: self dbDirectory fullName]
		on: ODBError
		do: [:ex | 
			retry := retry + 1.
			retry > 1
				ifTrue: [ex pass].
			self createDb.
			ex retry].
	^ db! !

!MuOmniBaseAccessor class methodsFor: 'actions' stamp: 'mu 8/18/2005 17:16'!
readDo: aBlock
	| tra |
	^[aBlock value: (tra := self db newReadOnlyTransaction)] ensure: [tra abort]
	! !


!MuOmniBaseAccessor class methodsFor: 'utilities' stamp: 'mu 8/22/2005 17:43'!
allRootChildNames
	"MuOmniBaseAccessor allRootChildNames"
	| keys |
	keys := SortedCollection new.
	self readDo: [:tra | keys addAll: (tra root keys)].
	^keys! !


!MuOmniBaseAccessor class methodsFor: 'accessing' stamp: 'MU 8/11/2005 16:53'!
db
	(db isNil or: [(OmniBase allSessions includes: db) not])
		ifTrue: [self openedDb].
	^ db! !

!MuOmniBaseAccessor class methodsFor: 'accessing' stamp: 'MU 8/10/2005 00:01'!
dbDirectory
	| subDirName |
	subDirName := self dbSubDirectoryName.
	(self dbRootDirectory directoryExists: subDirName)
		ifFalse: [self dbRootDirectory createDirectory: subDirName].
	^ self dbRootDirectory directoryNamed: subDirName! !

!MuOmniBaseAccessor class methodsFor: 'accessing' stamp: 'MU 8/10/2005 00:01'!
dbRootDirectory
	dbRootDirectory ifNil: [dbRootDirectory _ FileDirectory default].
	^dbRootDirectory! !

!MuOmniBaseAccessor class methodsFor: 'accessing' stamp: 'MU 8/10/2005 00:03'!
dbRootDirectory: aDirectory
	dbRootDirectory  _ aDirectory! !

!MuOmniBaseAccessor class methodsFor: 'accessing' stamp: 'MU 8/11/2005 17:30'!
dbSubDirectoryName
	dbSubDirectoryName ifNil: [dbSubDirectoryName := 'omniBaseDB'].
	^dbSubDirectoryName! !

!MuOmniBaseAccessor class methodsFor: 'accessing' stamp: 'MU 8/9/2005 23:58'!
dbSubDirectoryName: aString
	dbSubDirectoryName _ aString! !


!MuOmniBaseAccessor class methodsFor: 'class initialization' stamp: 'MU 8/15/2005 18:16'!
initialize
	"MuOmniBaseAccessor initialize"
	dbRootDirectory := dbSubDirectoryName := nil.! !

!MuOmniBaseAccessor class methodsFor: 'class initialization' stamp: 'MU 8/15/2005 18:19'!
release
	"MuOmniBaseAccessor release"
	dbRootDirectory := dbSubDirectoryName := nil.
	self closeAll.! !

MuOmniBaseAccessor initialize!